var currentPanel='tv';
var stretcher;
var maxHeight=300;
var mainContent;
var debugMode=false;

/**
 *   Array convenience method to check for membership.
 *
 *   @param object element
 *   @returns boolean
 */
Array.prototype.contains = function (element) {
    for (var i = 0; i < this.length; i++) {
        if (this[i] == element) {
            return true;
        }
    }
    return false;
};

Array.prototype.insertAt = function (what, iIndex) {
	if (iIndex < this.length) {
		var aAfter = this.splice(iIndex, 100000, what);
		for (var i = 0; i < aAfter.length; i++) {
			this.push(aAfter[i]);
		}
	} else {
		this.push(what);
	}
}

Array.prototype.getIndex = function (element) {
	//alert("coucou");
    for (var i = 0; i < this.length; i++) {
        if (this[i] == element) {
            return i;
        }
    }
    return -1;
};

/**
 *   Array convenience method to clear membership.
 *
 *   @param object element
 *   @returns void
 */
Array.prototype.clear = function () {
    this.length = 0;
};

Array.prototype.copy = function(list) {
	this.clear();
	for (var i=0;i<list.length;i++) {
		this.push(list[i]);
	}
}
        
/**
 *   Array convenience method to remove element.
 *
 *   @param object element
 *   @returns boolean
 */
Array.prototype.remove = function (element) {
        var result = false;
        var array = [];
        for (var i = 0; i < this.length; i++) {
                if (this[i] == element) {
                        result = true;
                } else {
                        array.push(this[i]);
                }
        }
        this.clear();
        for (var i = 0; i < array.length; i++) {
                this.push(array[i]);
        }
        array = null;
        return result;
};

/*String.prototype.replaceAll = function (search, value) {
	var result=this;
	if (this=="") return this;
	var oldValue=result;
	result=result.replace(search, value);
	//TRACE(oldValue+" "+result);
	while (oldValue!=result) {
		oldValue=result;
		result=result.replace(search, value);
		//TRACE(oldValue+" "+result);
	}
	return result;
};*/

String.prototype.replaceAll = function (findStr, repStr) {
	var srchNdx = 0;  // srchNdx will keep track of where in the whole line
				// of oldStr are we searching.
	var newStr = "";  // newStr will hold the altered version of oldStr.
	while (this.indexOf(findStr,srchNdx) != -1)  
				// As long as there are strings to replace, this loop
				// will run. 
	{
		newStr += this.substring(srchNdx,this.indexOf(findStr,srchNdx));
					// Put it all the unaltered text from one findStr to
					// the next findStr into newStr.
		newStr += repStr;
					// Instead of putting the old string, put in the
					// new string instead. 
		srchNdx = (this.indexOf(findStr,srchNdx) + findStr.length);
					// Now jump to the next chunk of text till the next findStr.           
	}
	newStr += this.substring(srchNdx,this.length);
				// Put whatever's left into newStr.             
	return newStr;
};


/************************
* simplifyName: Remove spaces and transform in to lower case 
************************/
function simplifyName(name) {
	var result=name.toLowerCase().replaceAll(" ","");
	return result;
}

/************************
* getDuree: Get delta between start and end
************************/
function getDuree(start, end) {
	var sh,eh,eh,em;
	if (start.substr(0,1)==":") start="1"+ start.substr(1,5);
	if (end.substr(0,1)==":") end="1"+ end.substr(1,5);
	sh = parseInt(start.substr(0,2),10);
	sm = parseInt(start.substr(3,2),10);
	eh = parseInt(end.substr(0,2),10);
	em = parseInt(end.substr(3,2),10);
	if (sh<24 && eh<sh) 
		eh=eh+24;
	return getDeltaTps(sh,sm,eh,em);
}

/************************
* getDeltaTps: Compute delta time
************************/
function getDeltaTps(sh,sm,eh,em) {
	var ds = sh*60+sm;
	var de = eh*60+em;
	return (de-ds);
}

/*************************
* format2digit : Return hour with 2 digits
*************************/
function format2digit(val) {
	var text="";
	text+=val;
	if (text.length==1) {
		text="0"+text;
	}
	return text;
}

/************************
* removeZero: Remove 0 at the begining of val
************************/
function removeZero(val){
	var result;
	if (val.length>=2) {
		if (val.substr(0,1)=="0") {
			result=val.substring(1,val.length);
		} else {
			result=val;
		}
	} else {
		result=val;
	}
	
	return result;
}

function displayTime(time) {
	return displayTimeSep(time, ":");
}

/************************
* displayTime: Format a time
************************/
function displayTimeSep(time, sep) {
	var h = parseInt(time.substr(0,2),10);
	var min = time.substr(3,2);
	var entete = "";
	if (h<0) h += 24;
	h %= 24;
	if (h <10) entete = "0";
	return entete+h+sep+min;
}

/************************
* compareHeure: Compare to hour
************************/
function compareHeure(h1, h2) {
	if (h1<h2) {
		return -1;
	}
	else if (h1==h2) {
		return 0;
	}
	else {
		return 1;
	}
}

function getObj(name)
{
  if (document.getElementById)
  {
  	this.obj = document.getElementById(name);
	this.style = document.getElementById(name).style;
  }
  else if (document.all)
  {
	this.obj = document.all[name];
	this.style = document.all[name].style;
  }
  else if (document.layers)
  {
   	this.obj = document.layers[name];
   	this.style = document.layers[name];
  }
}

/************************
* protecteSimpleCote: Add \\' before ' caracters 
************************/
function protecteSimpleCote(val) {
	var result=val.replaceAll("'", "\\'");
	return result;
}

/************************
* protecteDoubleCote: Add \" before " caracters 
************************/
function protecteDoubleCote(val) {
	var result=val.replaceAll("\"", "\\\"");
	return result;
}

function convertHTML2Txt(val) {
	var result=val.replaceAll("&rsquo;","'");
	return result;
}

/*************************
* getHourOn24 : Return hour on 24 hours format
*************************/
function getHourOn24(h) {
	return (h%24);
}

function waitingMessage() {
	var panel;
	if (currentPanel=="tv") {
		panel=document.getElementById("myTVContent");
	} else {
		panel=document.getElementById("myCineContent");
	}
	panel.innerHTML="<div class='message'>Chargement en cours...</div>";
	panel.innerHTML+="<div class='comment'>(si cela est trop long, veuillez slectionner une autre page)</div>";
	
	panel.innerHTML+="<br><div class='comment'>Si le problme persiste, veuillez me contacter <a class='link_black' href='#' onclick=onclick=\"clicked('mail:macpoupou1@mac.com');return false;\">ici</a>.</div>";
}


function readDOM(filename, cached) { 
	var result;
    request = new XMLHttpRequest(); 
    var sep = (-1 < filename.indexOf("?")) ? "&" : "?"
    var url=filename;
    //if (!cached) url+=sep+ "__=" + encodeURIComponent((new Date()).toString());
    var result =null;
    try {
    	request.open("GET", url ,false); 
    	if (!cached) request.setRequestHeader("Cache-Control", "no-cache"); 
		request.overrideMimeType("text/xml");	
    	request.send(null); 
    	result = request.responseText; 
    } catch (er) {
    	result=null;
    }
    if (result) return result ;
    else return null ;
}

function TRACE(msg) {
	if (debugMode) {
		if (window.widget) {
			alert(msg);
		} else {
			document.getElementById('debugDiv').innerHTML+=msg+"<br>";
		}
	} else {
		if (window.widget) {
			alert(msg);
		}
	}
}
