/************************
* seeInVLC: Call VLC to display channel
************************/
function seeInVLC(id, tvId) {
	//alert("seeInVLC: "+id+" "+tvId);
	var emission=getEmissionById(id, tvId);
	var chaine=emission.chaine;
	
	//alert("=>: "+emission.chaine.name+" "+emission.chaine.boxid+" "+emission.chaine.freebox+" "+emission.chaine.freeboxname);
	if(window.widget) {
		if (chaine.flavour.length>0) {
			popupEmission=emission;
			var popup=document.getElementById("popup");
			
			var sourcePopup=document.getElementById("sourcePopup").object;
			
			var listSource=new Array();
			for (var i=0;i<chaine.flavour.length;i++) {
				var typeName="";
				if (chaine.flavour[i].type=="hd") {
					typeName="HD";
				} else if (chaine.flavour[i].type=="ld") {
					typeName="Bas debit";
				} else {
					typeName="Normal";
				}
				listSource.push(typeName);
			}
			sourcePopup._setOptions(listSource);
			popupMode=0;
			popupApp=1;
			popupCommand="";
			popup.style.visibility="visible";
		} else {
			if (emission.chaine.freebox!="") {
				 openChannelInVLC(emission.chaine.freebox, null);
			}
		}
	}
}

function openChannelInVLC(channelId, flavour) {
	var channel_url="rtsp://mafreebox.freebox.fr/fbxtv_pub/stream?namespace=1&service="+channelId;
	//alert("*"+channel_url+"*");
	if (flavour) {
		channel_url+="&flavour="+flavour;
	}
	if (boxType=="neuvtv") {
		channel_url="http://80.118.196.219/webtv-asx.cgi?channel="+channelId;
	} else if (boxType=="belgacomtv") {
		channel_url="udp://@"+channelId;
	} else if (boxType=="livebox") {
		channel_url="udp://@"+channelId;
	} else if (boxType=="bbox") {
		channel_url="http://wm.live.tv-radio.com/bouygues/all/channel"+channelId+".wmv";
	} else if (boxType=="free") {
		channel_url="http://tv.freebox.fr/stream_"+channelId;
	}
	var commande="/usr/bin/osascript ./Freebox/OpenChannel.scpt \""+channel_url+"\"";
	var cmd=widget.system(commande,endFreeBoxCall);
}

function endFreeBoxCall(cmd) {
}

/************************
* recordInIMagneto: Record a program in iMagneto
************************/
function recordInIMagneto(emission_id, channel_id) {
	var emission=getEmissionById(channel_id, emission_id);
	
	var channel=emission.chaine.name;
	var name=emission.name;
	var debut=emission.start;
	var fin=emission.end;
	var day=emission.day;

	if (isEnCours(emission)) {
		var now=new Date();
		day=format2digit(now.getDate())+"/";
		day+=format2digit(now.getMonth()+1)+"/";
		day+=now.getFullYear();
		
		var hour=now.getHours();
		var minutes=now.getMinutes()+1;
		
		//if (hour>=0 && hour<4) {
		if (hour>=0 && hour<4) {
			hour+=24;
		}
		
		debut=format2digit(hour)+":"+format2digit(minutes);
	}

	if (callExtApp) TRACE(name+" "+channel+" "+debut+" "+fin+" "+day);
	var simpleName=name;
	
	var date;
	var date_re=/(\d\d)\/(\d\d)\/(\d\d\d\d)/;
	if (date_re.test(day)) {
		date_re.exec(day);
		date=new Date();
		var jour=RegExp.$1;
		var mois=RegExp.$2;
		var annee=RegExp.$3;
		
		jour=removeZero(jour);
		mois=removeZero(mois);
		//alert("-> "+jour+" "+mois+" "+annee);
		date.setDate(parseInt(jour));
		date.setMonth(parseInt(mois)-1);
		date.setYear(annee);
	}
	
	var time_re=/(\d\d):(\d\d)/;
	var hours;
	var minutes;
	
	if (time_re.test(debut)) {
		time_re.exec(debut);
		hours=RegExp.$1;
		minutes=RegExp.$2;
	}
	
	var endHours;
	var endMinutes;
	if (time_re.test(fin)) {
		time_re.exec(fin);
		endHours=RegExp.$1;
		endMinutes=RegExp.$2;
	}
	
	if (hours>=24) {
		date.setDate(date.getDate()+1);
	}
	
	date.setHours(getHourOn24(hours-1));
	date.setMinutes(minutes);
	
	var duree=getDuree(emission.start, emission.end);
	var endDate=new Date(date.valueOf()+(duree*60*1000));
	
	var description=simpleName;
	
	var param1=date.getDate()+"/"+(date.getMonth()+1)+"/"+date.getFullYear()+" "+format2digit(date.getHours()+1)+":"+format2digit(date.getMinutes())+":0";
	var param2=getDuree(debut, fin);
	var param3=simpleName;
	var param4=channel;
	var param5=description;
	var param6=emission.chaine.freebox;
	
	var startDate=format2digit(date.getDate())+"/"+format2digit(date.getMonth()+1)+"/"+date.getFullYear();
	var startTime=hours+"h"+minutes;
	var stopData=format2digit(endDate.getDate())+"/"+format2digit(endDate.getMonth()+1)+"/"+endDate.getFullYear();
	var stopTime=endHours+"h"+endMinutes;
	
	var commande="Freebox/imagsocket \""+emission.chaine.freeboxName+"\" "+startDate+" "+startTime+" "+stopData+" "+stopTime+" \""+emission.name+"\"";
	//var commande="/usr/bin/osascript ./Freebox/Record.scpt \""+param1+"\" \""+param2+"\" \""+param3+"\"  \""+param4+"\"  \""+param5+"\" \""+param6+"\"";
	if (callExtApp) TRACE(commande);
	var cmd=widget.system(commande,null);
	if (callExtApp) {
		TRACE(cmd.outputString);
	}
}

/************************
* recordInVLC: Record a program in VLC by iCal
************************/
function recordInVLC(emission_id, channel_id) {
	var emission=getEmissionById(channel_id, emission_id);
	
	var channel=emission.chaine.name;
	var name=emission.name;
	var debut=emission.start;
	var fin=emission.end;
	var day=emission.day;

	if (isEnCours(emission)) {
		var now=new Date();
		day=format2digit(now.getDate())+"/";
		day+=format2digit(now.getMonth()+1)+"/";
		day+=now.getFullYear();
		
		var hour=now.getHours();
		var minutes=now.getMinutes()+1;
		
		if (hour>=0 && hour<4) {
			hour+=24;
		}
		
		debut=format2digit(hour)+":"+format2digit(minutes);
	}

	if (callExtApp) TRACE(name+" "+channel+" "+debut+" "+fin+" "+day);
	var simpleName=name;
	var simpleName2=name.replaceAll("","i");
	simpleName2=simpleName2.replaceAll("","a");
	simpleName2=simpleName2.replaceAll("","e");
	simpleName2=simpleName2.replaceAll("","e");
	simpleName2=simpleName2.replaceAll("","e");
	simpleName2=simpleName2.replaceAll("/","_");
	simpleName2=simpleName2.replaceAll("!","_");
	simpleName2=simpleName2.replaceAll(":","_");
	simpleName2=simpleName2.replaceAll("=","_");
	simpleName2=simpleName2.replaceAll("'","_");
	simpleName2=simpleName2.replaceAll(" ","_");
	
	var date;
	var date_re=/(\d\d)\/(\d\d)\/(\d\d\d\d)/;
	if (date_re.test(day)) {
		date_re.exec(day);
		date=new Date();
		var jour=RegExp.$1;
		var mois=RegExp.$2;
		var annee=RegExp.$3;
		
		jour=removeZero(jour);
		mois=removeZero(mois);
		//alert("-> "+jour+" "+mois+" "+annee);
		date.setDate(parseInt(jour));
		date.setMonth(parseInt(mois)-1);
		date.setYear(annee);
	}
	
	var time_re=/(\d\d):(\d\d)/;
	var hours;
	var minutes;
	
	if (time_re.test(debut)) {
		time_re.exec(debut);
		hours=RegExp.$1;
		minutes=RegExp.$2;
	}
	
	var endHours;
	var endMinutes;
	if (time_re.test(fin)) {
		time_re.exec(fin);
		endHours=RegExp.$1;
		endMinutes=RegExp.$2;
	}
	
	if (hours>=24) {
		date.setDate(date.getDate()+1);
	}
	
	date.setHours(getHourOn24(hours-1));
	date.setMinutes(minutes);
	
	var endDate=new Date(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), 0);
	endDate.setMinutes(endDate.getMinutes()+getDuree(debut, fin));
	
	var description=simpleName2;
	
	var param1=date.getDate()+"/"+(date.getMonth()+1)+"/"+date.getFullYear()+" "+format2digit(date.getHours()+1)+":"+format2digit(date.getMinutes())+":0";
	var param2=getDuree(debut, fin);
	var param3=simpleName;
	var param4=channel;
	var param5=description;
	var param6=emission.chaine.freebox;
	
	var commande="/usr/bin/osascript ./Freebox/Record.scpt \""+param1+"\" \""+param2+"\" \""+param3+"\"  \""+param4+"\"  \""+param5+"\" \""+param6+"\"";
	if (callExtApp) TRACE(commande);
	var cmd=widget.system(commande,endAppleScriptCall);
}

/************************
* getPlayListFromFree: Launch autoconf
************************/
function getPlayListFromFree() {	
	if (window.widget) {
		var commande="./Freebox/autoconf.app/Contents/MacOS/autoconf";
		//TRACE(commande);
		widget.system(commande, refreshFreeBox);
	}
}

/************************
* refreshFreeBox: Call after autoconf end
************************/
function refreshFreeBox(cmd) {
	//freeboxNetChecked=true;
	freeboxChannelsChecked=false;
	//sauvegarde de freeboxNetChecked dans les prefs du widget
	//widget.setPreferenceForKey(freeboxNetChecked,createkey("freeboxNetChecked"));
		
	initFreeBoxChannels();
	if (isFreeboxDetected) {
		if (boxType=="freeboxtv") {
			document.getElementById("freeboxtvlogo").style.display="block";
			document.getElementById("neuftvlogo").style.display="none";
			document.getElementById("belgacomtvlogo").style.display="none";
			document.getElementById("liveboxlogo").style.display="none";
			document.getElementById("bboxlogo").style.display="none";
		} else if (boxType=="neuftv") {
			document.getElementById("freeboxtvlogo").style.display="none";
			document.getElementById("neuftvlogo").style.display="block";
			document.getElementById("belgacomtvlogo").style.display="none";
			document.getElementById("liveboxlogo").style.display="none";
			document.getElementById("bboxlogo").style.display="none";
		} else if (boxType=="belgacomtv") {
			document.getElementById("freeboxtvlogo").style.display="none";
			document.getElementById("neuftvlogo").style.display="none";
			document.getElementById("belgacomtvlogo").style.display="block";
			document.getElementById("liveboxlogo").style.display="none";
			document.getElementById("bboxlogo").style.display="none";
		} else if (boxType=="livebox") {
			document.getElementById("freeboxtvlogo").style.display="none";
			document.getElementById("neuftvlogo").style.display="none";
			document.getElementById("belgacomtvlogo").style.display="none";
			document.getElementById("liveboxlogo").style.display="block";
			document.getElementById("bboxlogo").style.display="none";
		} else if (boxType=="bbox") {
			document.getElementById("freeboxtvlogo").style.display="none";
			document.getElementById("neuftvlogo").style.display="none";
			document.getElementById("belgacomtvlogo").style.display="none";
			document.getElementById("liveboxlogo").style.display="none";
			document.getElementById("bboxlogo").style.display="block";
		} else {
			document.getElementById("freeboxtvlogo").style.display="none";
			document.getElementById("neuftvlogo").style.display="none";
			document.getElementById("belgacomtvlogo").style.display="none";
			document.getElementById("liveboxlogo").style.display="none";
			document.getElementById("bboxlogo").style.display="none";
		}
	} 
	tv_update();
}



function updateBoxTV() {
	boxType=document.getElementById("tv_prefBoxValue").options[document.getElementById("tv_prefBoxValue").selectedIndex].value;
	document.getElementById("tv_prefFreeboxTVChannelList").innerHTML="<option>Please Wait...";
	
	freeboxChannelsChecked=false;
	var channel;
	for (var i=0;i<channelsList.length;i++) {
		channel=channelsList[i];
		channel.freebox="";
		channel.freeboxName="";
		channel.boxid="";
	}
	saveFreeboxTVLinks="";
	freeboxChannelsChecked=false;
	widget.setPreferenceForKey(boxType, createkey("boxType"));
	widget.setPreferenceForKey(saveFreeboxTVLinks, createkey("saveFreeboxTVLinks"));
	if (boxType!="") initFreeBoxChannels();
	displayOnglet("freebox");
}

/************************
* initFreeBoxChannels: Init Freebox channel by reading playlist m3u
************************/
function initFreeBoxChannels() {
	if (boxType=="") {
		isFreeboxDetected=false;
		freeboxChannelsChecked=true;
		return;
	}
	if (freeboxChannelsChecked) return;
	//var freeboxFile=userFolder+"/Library/Application Support/Widget_CineTV/Freebox/playlist.m3u";
	var freeboxFile="file://"+widgetDir+"/Data/"+boxType+".m3u";
	
	
	for (var j=0;j<channelsList.length;j++) {
		channelsList[j].flavour.clear();
	}
	
	//alert(freeboxFile);
	//freeboxFile="http://mafreebox.freebox.fr/freeboxtv/playlist.m3u";
	
	if (boxType=="usertv") {
		freeboxFile=userFolder+"/Library/Application Support/Widget_CineTV/usertv.csv";
	}
	
	var page=readDOMLimitedTile(freeboxFile, true);
	freeboxChannelsChecked=true;
	//return;
	
	/*if (page==null) {
		if (!freeboxNetChecked) getPlayListFromFree();
		return;
	}*/
	if (boxType=="freeboxtv" || boxType=="free") {
		document.getElementById("freeboxtvlogo").style.display="block";
		document.getElementById("neuftvlogo").style.display="none";
		document.getElementById("belgacomtvlogo").style.display="none";
		document.getElementById("liveboxlogo").style.display="none";
		document.getElementById("bboxlogo").style.display="none";
	} else if (boxType=="neuftv") {
		document.getElementById("freeboxtvlogo").style.display="none";
		document.getElementById("neuftvlogo").style.display="block";
		document.getElementById("belgacomtvlogo").style.display="none";
		document.getElementById("liveboxlogo").style.display="none";
		document.getElementById("bboxlogo").style.display="none";
	} else if (boxType=="belgacomtv") {
		document.getElementById("freeboxtvlogo").style.display="none";
		document.getElementById("neuftvlogo").style.display="none";
		document.getElementById("belgacomtvlogo").style.display="block";
		document.getElementById("liveboxlogo").style.display="none";
		document.getElementById("bboxlogo").style.display="none";
	} else if (boxType=="livebox") {
		document.getElementById("freeboxtvlogo").style.display="none";
		document.getElementById("neuftvlogo").style.display="none";
		document.getElementById("belgacomtvlogo").style.display="none";
		document.getElementById("liveboxlogo").style.display="block";
		document.getElementById("bboxlogo").style.display="none";
	} else if (boxType=="bbox") {
		document.getElementById("freeboxtvlogo").style.display="none";
		document.getElementById("neuftvlogo").style.display="none";
		document.getElementById("belgacomtvlogo").style.display="none";
		document.getElementById("liveboxlogo").style.display="none";
		document.getElementById("bboxlogo").style.display="block";
	} else {
		document.getElementById("freeboxtvlogo").style.display="none";
		document.getElementById("neuftvlogo").style.display="none";
		document.getElementById("belgacomtvlogo").style.display="none";
		document.getElementById("liveboxlogo").style.display="none";
		document.getElementById("bboxlogo").style.display="none";
	}
	
	document.getElementById("tv_content").className="tv_content";
	//waitingFreeBoxTVPanel();
	
	
	
	isFreeboxDetected=true;
	var lines=page.split("\n");
	var chaine_re=/.+?:\d,(\d+) - (.+?)$/;
	var hdChaine_re=/(.+?) HD$/;
	var basdebitChaine_re=/(.+?) \(bas d.+?t\)$/;
	
	//var flux_re=/rtsp:\/\/mafreebox.freebox.fr\/freeboxtv\/(.+?)$/;
	//var flux_re=/rtsp:\/\/mafreebox.freebox.fr\/fbxtv_pub\/stream\?namespace=1&service=(\d+).*$/;
	var flux_re=/rtsp:\/\/mafreebox.freebox.fr\/fbxtv_pub\/stream\?namespace=1&service=(\d+)(.*)$/;
	var flavour_re=/&flavour=(.*)$/;
	
	if (boxType=="neuftv") {
		//chaine_re=/.+?:\d,(\d+) - (.+?)$/;
		flux_re=/http:\/\/80.118.196.219\/webtv-asx.cgi\?channel=(.+?)$/;
	} else if (boxType=="belgacomtv") {
		flux_re=/udp:\/\/@(.+?)$/;
	} else if (boxType=="livebox") {
		flux_re=/udp:\/\/@(.+?)$/;
	} else if (boxType=="bbox") {
		flux_re=/http:\/\/wm.live.tv-radio.com\/bouygues\/all\/channel(\d+).wmv$/;
		//flux_re=/udp:\/\/@(.+?)$/;
	} else if (boxType=="usertv") {
		chaine_re=/(\d+);(.+?)$/;
	} else if (boxType=="free") {
		flux_re=/http:\/\/tv.freebox.fr\/stream_(.*)$/;
	}
	var line="";
	var name="";
	var boxid="";
	saveFreeboxTVLinks="";
	var isHDChannel=false;
	var isBasDebitChannel=false;
	for (var i=0;i<lines.length;i++) {
		line=lines[i];
		if (chaine_re.test(line)) {
			chaine_re.exec(line);
			boxid=RegExp.$1;
			name=RegExp.$2;
			isHDChannel=false;
			isBasDebitChannel=false;
			
			if (hdChaine_re.test(name)) {
				hdChaine_re.exec(name);
				name=RegExp.$1;
				isHDChannel=true;
				if (debugFreeboxChannelCall) TRACE("isHDChannel: "+isHDChannel);
			} else if (basdebitChaine_re.test(name)) {
				basdebitChaine_re.exec(name);
				name=RegExp.$1;
				isBasDebitChannel=true;
				if (debugFreeboxChannelCall) TRACE("isBasDebitChannel: "+isBasDebitChannel);
			} else {
				if (debugFreeboxChannelCall) TRACE("normalChannel");
			}
			
			//alert(boxid+" "+name);
			if (debugFreeboxChannelCall) TRACE("Chaine *"+name+"* "+(isHDChannel?"HD":(isBasDebitChannel?"Bas debit":"Normal")));
			/*chaine=searchChannelLikeName(name);
			if (chaine) {
				if (debugFreeboxChannelCall) TRACE("-> Found "+chaine.name);
			} else {
				if (debugFreeboxChannelCall) TRACE("-> Not Found");
			}*/
			
			if (boxType=="usertv") {
				var searchName=transformChannelNameForEyeTV(name);
				for (var j=0;j<channelsList.length;j++) {
					tmpChannel=channelsList[j];
					var channelName=transformChannelNameForEyeTV(tmpChannel.name);
					
					if (channelName==searchName) {
						channel=tmpChannel;
						channel.boxid=boxid;
						saveFreeboxTVLinks+=channel.id+"~"+channel.freebox+"~"+channel.freeboxName+"~"+channel.boxid+"\n";
					} else {
						//TRACE("*"+name+"* *"+searchName+"* *"+channelName+"*");
					}
				}
			}
			
		}
		if (flux_re.test(line)) {
			flux_re.exec(line);
			if (name!="") {
				var idFreebox=RegExp.$1;
				var optionFlux=RegExp.$2;
				var flavour="";
				if (optionFlux!="") {
					if (flavour_re.test(optionFlux)) {
						flavour_re.exec(optionFlux)
						flavour=RegExp.$1;
					}
				}
				var channel=null;
				var searchName=transformChannelNameForEyeTV(name);
				if (debugFreeboxChannelCall) TRACE("->searchName *"+searchName+"*");
				
				
				
				var tmpChannel=null;
				for (var j=0;j<channelsList.length;j++) {
					tmpChannel=channelsList[j];
					var channelName=transformChannelNameForEyeTV(tmpChannel.name);
					
					if (channelName==searchName) {
						channel=tmpChannel;
						channel.boxid=boxid;
						channel.freebox=idFreebox;
						channel.freeboxName=name;
						if (flavour!="") {
							if (debugFreeboxChannelCall) TRACE("Add flavour "+flavour);
							channel.flavour.push(newFlavour(idFreebox,flavour));
						}
						
						if (debugFreeboxChannelCall) TRACE("freebox: "+name+" found at "+channel.id);
						//alert("flux : "+channel.freebox+" "+channel.freeboxName);
					} else {
						//TRACE("*"+name+"* *"+searchName+"* *"+channelName+"*");
					}
				}
				
				
				if (channel==null) {
					if (debugFreeboxChannelCall) TRACE("freebox: "+name+" not found in WidgetCineTV");
				}
				
				
				name="";
			}
		}
		
	}
	for (var j=0;j<channelsList.length;j++) {
		channel=channelsList[j];
		if (channel.boxid!="") {
			saveFreeboxTVLinks+=channel.id+"~"+channel.freebox+"~"+channel.freeboxName+"~"+channel.boxid;
			if (channel.flavour.length>0) {
				saveFreeboxTVLinks+="~";
				for (var i=0;i<channel.flavour.length;i++) {
					if (i>0) saveFreeboxTVLinks+=";";
					saveFreeboxTVLinks+=channel.flavour[i].id+"/"+channel.flavour[i].type;
				}
			}
			saveFreeboxTVLinks+="\n";
		}
	}
	widget.setPreferenceForKey(saveFreeboxTVLinks, createkey("saveFreeboxTVLinks"));
}